// Generated by CoffeeScript 1.8.0
(function() {
  angular.module('ajenti.plugins', ['core']);

}).call(this);

// Generated by CoffeeScript 1.8.0
(function() {
  angular.module('core').config(function($routeProvider) {
    return $routeProvider.when('/view/plugins', {
      templateUrl: '/plugins:resources/partial/index.html',
      controller: 'PluginsIndexController'
    });
  });

}).call(this);

// Generated by CoffeeScript 1.8.0
(function() {
  angular.module('ajenti.plugins').controller('PluginsIndexController', function($scope, $q, $http, notify, pageTitle, messagebox, tasks, core) {
    pageTitle.set('Plugins');
    $scope.officialKeyFingerprint = '425E 018E 2394 4B4B 4281  4EE0 BDC3 FBAA 5302 9759';
    $scope.selectedInstalledPlugin = null;
    $scope.selectedRepoPlugin = null;
    $scope.coreUpgradeAvailable = null;
    $scope.selectRepoPlugin = function(plugin) {
      return $scope.selectedRepoPlugin = plugin;
    };
    $scope.refresh = function() {
      $http.get('/api/plugins/list/installed').success(function(data) {
        $scope.installedPlugins = data;
        $scope.repoList = null;
        $scope.repoListOfficial = null;
        $scope.repoListCommunity = null;
        return $http.get('/api/plugins/repo/list').success(function(data) {
          var x;
          $scope.repoList = data;
          $scope.notInstalledRepoList = (function() {
            var _i, _len, _ref, _results;
            _ref = $scope.repoList;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              x = _ref[_i];
              if (!$scope.isInstalled(x)) {
                _results.push(x);
              }
            }
            return _results;
          })();
          $scope.repoListOfficial = (function() {
            var _i, _len, _ref, _results;
            _ref = $scope.repoList;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              x = _ref[_i];
              if (x.signature === $scope.officialKeyFingerprint) {
                _results.push(x);
              }
            }
            return _results;
          })();
          return $scope.repoListCommunity = (function() {
            var _i, _len, _ref, _results;
            _ref = $scope.repoList;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              x = _ref[_i];
              if (x.signature !== $scope.officialKeyFingerprint) {
                _results.push(x);
              }
            }
            return _results;
          })();
        }).error(function(err) {
          return notify.error('Could not load plugin repository', err.message);
        });
      }).error(function(err) {
        return notify.error('Could not installed plugin list', err.message);
      });
      $http.get('/api/plugins/core/check-upgrade').success(function(data) {
        return $scope.coreUpgradeAvailable = data;
      });
      $scope.pypiList = null;
      return $http.get('/api/plugins/pypi/list').success(function(data) {
        return $scope.pypiList = data;
      });
    };
    $scope.refresh();
    $scope.upgradeCore = function() {
      var msg;
      msg = messagebox.show({
        progress: true,
        title: 'Upgrading'
      });
      return $http.get("/api/plugins/core/upgrade/" + $scope.coreUpgradeAvailable).success(function() {
        return messagebox.show({
          title: 'Done',
          text: 'Upgrade complete. A panel restart is absolutely required.',
          positive: 'Restart now'
        }).then(function() {
          return core.forceRestart();
        });
      }).error(function(err) {
        return notify.error('Upgrade failed', err.message);
      })["finally"](function() {
        return msg.close();
      });
    };
    $scope.isInstalled = function(plugin) {
      var p, _i, _len, _ref;
      if (!$scope.isInstalled) {
        return false;
      }
      _ref = $scope.installedPlugins;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        if (p.name === plugin.name) {
          return true;
        }
      }
      return false;
    };
    $scope.isUninstallable = function(plugin) {
      return $scope.pypiList && $scope.pypiList[plugin.name] && plugin.name !== 'core';
    };
    $scope.isAnythingUpgradeable = function() {
      var p, _i, _len, _ref;
      if (!$scope.installedPlugins) {
        return false;
      }
      if ($scope.coreUpgradeAvailable) {
        return true;
      }
      _ref = $scope.installedPlugins;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        if ($scope.getUpgrade(p)) {
          return true;
        }
      }
      return false;
    };
    $scope.upgradeEverything = function() {
      return $scope.upgradeAllPlugins().then(function() {
        if ($scope.coreUpgradeAvailable) {
          return $scope.upgradeCore();
        } else {
          notify.success('All plugins updated');
          return messagebox.show({
            title: 'Done',
            text: 'Installed. A panel restart is required.',
            positive: 'Restart now',
            negative: 'Later'
          }).then(function() {
            return core.forceRestart();
          });
        }
      })["catch"](function() {
        return notify.error('Some plugins failed to update');
      });
    };
    $scope.upgradeAllPlugins = function() {
      var msg, p, plugin, q, rqQs, upgrade, upgradeQs, _i, _len, _ref;
      q = $q.defer();
      rqQs = [];
      upgradeQs = [];
      _ref = $scope.installedPlugins;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        plugin = _ref[_i];
        upgrade = $scope.getUpgrade(plugin);
        if (upgrade) {
          p = tasks.start('aj.plugins.plugins.tasks.InstallPlugin', [], {
            name: upgrade.name,
            version: upgrade.version
          });
          rqQs.push(p);
          p.then(function(data) {
            return upgradeQs.push(data.promise);
          });
        }
      }
      if (rqQs.length === 0) {
        q = $q.defer();
        q.resolve();
        return q.promise;
      }
      msg = messagebox.show({
        progress: true,
        title: 'Updating plugins'
      });
      $q.all(rqQs).then(function() {
        return $q.all(upgradeQs).then(function() {
          return q.resolve();
        })["catch"](function() {
          return q.reject();
        })["finally"](function() {
          return msg.close();
        });
      });
      return q.promise;
    };
    $scope.getUpgrade = function(plugin) {
      var p, _i, _len, _ref;
      if (!$scope.repoList || !plugin) {
        return null;
      }
      _ref = $scope.repoList;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        p = _ref[_i];
        if (p.name === plugin.name && p.version !== plugin.version) {
          return p;
        }
      }
      return null;
    };
    $scope.installPlugin = function(plugin) {
      var msg;
      $scope.selectedRepoPlugin = null;
      $scope.selectedInstalledPlugin = null;
      msg = messagebox.show({
        progress: true,
        title: 'Installing'
      });
      return tasks.start('aj.plugins.plugins.tasks.InstallPlugin', [], {
        name: plugin.name,
        version: plugin.version
      }).then(function(data) {
        return data.promise.then(function() {
          $scope.refresh();
          messagebox.show({
            title: 'Done',
            text: 'Installed. A panel restart is required.',
            positive: 'Restart now',
            negative: 'Later'
          }).then(function() {
            return core.forceRestart();
          });
          return null;
        })["catch"](function(e) {
          return notify.error('Install failed', e.error);
        })["finally"](function() {
          return msg.close();
        });
      });
    };
    $scope.uninstallPlugin = function(plugin) {
      if (plugin.name === 'plugins') {
        return messagebox.show({
          title: 'Warning',
          text: 'This will remove the Plugins plugin. You can reinstall it later using PIP.',
          positive: 'Continue',
          negative: 'Cancel'
        }).then(function() {
          return $scope.doUninstallPlugin(plugin);
        });
      } else {
        return $scope.doUninstallPlugin(plugin);
      }
    };
    $scope.doUninstallPlugin = function(plugin) {
      $scope.selectedRepoPlugin = null;
      $scope.selectedInstalledPlugin = null;
      return messagebox.show({
        title: 'Uninstall',
        text: "Uninstall " + plugin.name + "?",
        positive: 'Uninstall',
        negative: 'Cancel'
      }).then(function() {
        var msg;
        msg = messagebox.show({
          progress: true,
          title: 'Uninstalling'
        });
        return $http.get("/api/plugins/pypi/uninstall/" + plugin.name).success(function() {
          $scope.refresh();
          return messagebox.show({
            title: 'Done',
            text: 'Uninstalled. A panel restart is required.',
            positive: 'Restart now',
            negative: 'Later'
          }).then(function() {
            return core.forceRestart();
          });
        }).error(function(err) {
          return notify.error('Uninstall failed', err.message);
        })["finally"](function() {
          return msg.close();
        });
      });
    };
    return $scope.restart = function() {
      return core.restart();
    };
  });

}).call(this);

